# https://gitlab.com/gitlab-org/gitlab-runner/-/issues/26501
# run-scorecard:
#   stage: test
#   image:
#     name: gcr.io/openssf/scorecard:stable
#     entrypoint:
#       - ''
#   variables:
#     SCORECARD_EXPERIMENTAL: "1"
#     GITLAB_AUTH_TOKEN: $READONLY_AUTH_TOKEN
#   script:
#     - /scorecard --repo $CI_PROJECT_URL
#

stages:
  - test
  - deploy

# debug:
#   stage: test
#   image: busybox
#   script:
#     - echo "$CI_PROJECT_PATH_SLUG"
#     - echo "$CI_PROJECT_PATH"
#     - echo "$CI_COMMIT_REF_NAME"

run-scorecard:
  stage: test
  services:
    - docker:dind
  image:
    name: docker:dind
  script:
    - echo 'Running scorecard'
    - docker run -v $PWD:/out -e SCORECARD_EXPERIMENTAL=1 -e GITLAB_AUTH_TOKEN=$READONLY_AUTH_TOKEN gcr.io/openssf/scorecard:stable --repo $CI_PROJECT_URL --output /out/report.json --format json
    - cat report.json
  artifacts:
    when: on_success
    paths:
      - report.json
    expire_in: "1 hour"

deploy:
  image: golang:1.22-alpine
  stage: deploy
  needs:
    - run-scorecard
  id_tokens:
    CI_JOB_JWT:
      aud: ""
    SIGSTORE_ID_TOKEN:
      aud: sigstore
  script:
    - go run .
